/*  VER 092  TAB P   $Id: common.h,v 1.20 1997/01/02 10:38:48 src Exp src $
 *
 *  common header file
 *
 *  copyright 1996 Egil Kvaleberg, egilk@sn.no
 *  the GNU General Public License applies
 */

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include "version.h"
#include "tune.h"

/* standard stuff */
#include <stdio.h>
#include <sys/types.h>
#include <ctype.h>

#if STDC_HEADERS
#  include <stdlib.h>
#  include <string.h>
#else 
#  if HAVE_STDLIB_H
#    include <stdlib.h>
#  endif
#  if HAVE_MALLOC_H
#    include <string.h>
#  endif
#  if HAVE_STRING_H
#    include <string.h>
#  else 
#    if HAVE_STRINGS_H
#      include <strings.h>
#    endif
#  endif
#endif

#if HAVE_UNISTD_H
#  include <unistd.h>
#endif

#if HAVE_LIMITS_H
#  include <limits.h>
#endif

#if TIME_WITH_SYS_TIME
#  include <time.h>
#  include <sys/time.h>
#else
#  if HAVE_SYS_TIME_H
#    include <sys/time.h>
#  else
#    include <time.h>
#  endif
#endif

/*
 *  not all versions define these..
 */
#ifndef PATH_MAX
#define PATH_MAX 1024
#endif

#ifndef __STDC__
extern int errno;
#endif

/*
 *  own socket stuff
 */
#include "sock.h"

/* 
 *  names
 */
char *hostname; 		/* current NNTP server */
char *spoolname;		/* outgoing spool */
char *hostport; 		/* port for NNTP server */
char *pname;			/* this program */
char *spooldir; 		/* news spool */

/* 
 *  statistics, article counters
 */
int duplicate_articles; 	/* duplicate articles */
int missing_articles;		/* missing articles */
int posted_articles;		/* new articles */
long fetched_articles;		/* number of articles fetched */
long fetched_groups;		/* number of groups fetched */
int fetch_aborted;		/* fetch aborted, usually due to timeout */
long unseen_groups;		/* groups not seen before */
long unavailable_groups;	/* groups not on server */
long already_articles;		/* number of articles already read */
long history_articles;		/* number of articles in history database */
long net_bytecount;		/* total size of articles */
long gross_bytecount;		/* total size of NNTP traffic */

/* 
 *  options 
 */
char *ai_username,*ai_password; /* -a username/password */
int minspool;			/* -b n */
int debug_flag; 		/* -d */
char *end_tag;			/* -e end_tag */
char *folder;			/* -f folder */
int nopull_opt; 		/* -g */
char *history;			/* -h history */
int inn_flag;			/* -i */
int keep_path_flag;		/* -k */
char *logfile;			/* -l logfile */
int nomsgid_flag;		/* -m */
int noaction_flag;		/* -n */
int keep_old_flag;		/* -o */
int nopost_opt; 		/* -p */
int mode_reader_flag;		/* -r */
int timeout;			/* -t n */
int noforce_flag;		/* -u */
char *chat_file;		/* -w chat */
char *connect_exec;		/* -x cmd */
char *via_exec; 		/* -y cmd */
int zap_flag;			/* -z */
int reset_flag; 		/* -R */
char *active;			/* -A active */
char *batch;			/* -B batch */
char *ctlpgm;			/* -C ctlinnd */
int conterr;			/* -E ignore */
char *newshome; 		/* -H newshome */
char *incoming; 		/* -I incoming */
char *newsfeeds;		/* -N newsfeeds */
char *togo;			/* -T togo */
int window;			/* -W windowsize */
int zapnew_flag;		/* -Z */

extern char *newline;

/* 
 *  misc status
 */
int post_allowed;

/* 
 *  log message types 
 */
#define L_ERR	 '?'
#define L_ERRno  '!'
#define L_INFO	 '&'
#define L_DEBUG  '='
#define L_DEBUG3 '3'
#define L_GET	 '<'
#define L_PUT	 '>'
