.\" $Id: newsx.man,v 1.22 1996/12/30 07:06:45 src Exp $
.\"
.\" NewsX man page
.\"
.\" copyright 1996 Egil Kvaleberg, egilk@sn.no
.\" Husebybakken 14A, N-0379 Oslo, Norway         
.\"
.\" This program is free software; you can redistribute it and/or modify
.\" it under the terms of the GNU General Public License.
.\"
.SH NAME
.I newsx
\- news server exchange \- post and fetch news articles

.SH SYNOPSIS
.I newsx
[
.I options
] [ 
.I spoolname
[ [
.I hostname
]
.I port
] ]

.SH DESCRIPTION
.PP
.I NewsX
is a client connecting to an NNTP server,
posting outgoing articles batched by the news system,
while also fetching new incoming articles from the same newsserver.
.PP
It provides the NNTP capabilities required for serving a small local news
spool such as those that may be found on installations with NNTP access 
through limited ISP accounts only, as well as
being suitable for exchanging news with supplemental news sources for
full scale large news servers.

.SH ARGUMENTS
.TP
.I options
As detailed below.
.TP
.I spoolname
The name of the outgoing spool queue. 
If not specified, the value of the 
NNTPSERVER environment variable will be used.
.TP
.I hostname
The hostname of the remote NNTP server to connect to. If not specified,
the name of the spool will be used.
.TP
.I port
The port used for connecting to 
.I hostname.
Will usually not need to be specified, and port "nntp" will be assumed.
The port name "telnet" will receive special treatment.

.SH OPTIONS FOR LOGGING
.TP
\fB-f\fP\fI folder\fP, \fB--posted\fP\fI folder\fP
Posted articles will be appended to the standard
mail folder indicated. 
Note that the article will be added to the
folder the first time posting of an article is attempted. 
The actual status of the posting will appear in the
log file.
.TP
\fB-l\fP\fI logfile\fP, \fB--log\fP\fI logfile\fP
Log information about successfully posted articles to the file indicated.

.SH OPTIONS FOR NEWS ACCESS
.TP
\fB-a\fP\fI authfile\fP, \fB--auth\fP\fI authfile\fP
If specified, the username and password combination found in
.I authfile
will be sent to the server as part of the simple authorization protocol
when the connection is first made. The file should consist of a line
with two blank-separated words, the first being the username, the second
the password. Do ensure that this file only has read access only for
those users that need to know.
.TP
\fB-r\fP, \fB--reader\fP
A 'MODE READER' command is sent to the remote server. This is used when
connecting to remote INN hosts that needs it. 
.TP
\fB-w\fP\fI chatfile\fP, \fB--chat\fP\fI chatfile\fP
Use
.I chatfile
to control any special connect sequence that may be required before the
NNTP protocol is connected. Only implemented for the "telnet" protocol.
.TP
\fB-x\fP\fI command\fP, \fB--exec\fP\fI command\fP
If specified, the 
.I command
will be executed after the host port has been opened. This option is used
in rare cases when special tricks has to be employed to get an NNTP
connection activated.
.TP
\fB-y\fP\fI program\fP, \fB--connect\fP\fI program\fP
If specified, connect via a bidirectional pipe to
.I program
instead of to a socket. The hostname and port arguments will be ignored.

.SH OPTIONS FOR POSTING
.TP
\fB-p\fP, \fB--nopost\fP
Do not attempt to do any posting. 
.TP
\fB-m\fP, \fB--nomsgid\fP
Remove any message-ID header field from the posted message. This should 
cause the receiving end to generate a fresh message-ID.
.TP
\fB-k\fP, \fB--keeppath\fP
Keep the "Path" when posting. Normally, the "Path" is stripped together with
the "NNTP-Posting-Host" and "Xref" header items, so that the path of the
news article as posted will appear to start at the actual posting host.
.TP
\fB--togo\fP\fI togofile\fP
Specify the name of the C News 
.I togo
file for outgoing news. No effect in INN mode.
Required only if different from the default value
.IR "\*o/\fIspoolname\fP/togo" "."
A leading '/' specifices a full path,	
a leading '.' is relative from the current directory, 
otherwise the name is relative to 
.IR "\*o/\fIspoolname\fP" "."
.TP
\fB--batch\fP\fI batchdir\fP
Use 
.I batchdir
as the outgoing news article spool directory instead of the default
.BR "\*b" .
A leading '/' specifices a full path,	
a leading '.' is relative from the current directory, 
otherwise the name is relative to 
.IR "\*s" "."
.TP
\fB--continue\fP
Ignore (but report) errors about non-existing outgoing spools, and 
continue with news fetching instead.

.SH OPTIONS FOR FETCHING
.TP
\fB-g\fP, \fB--nofetch\fP
Do not attempt to fetch (get) any news articles.
.TP
\fB-e\fP\fI end_tag\fP, \fB--end\fP\fI end_tag\fP
Specify a tag in the host newsrc file (\fIin.hosts/spoolname\fP).
News fetching will end when the tag indicated has been reached. 
This is a useful tool for dividing
the newsgroups into several categories. Only a few newsgroups may be
fetched during prime time, whereas the full list can be fetched once
every night, for instance.
.TP
\fB-W\fP\fI winsize\fP, \fB--window\fP\fI winsize\fP
Specify the
.I window
size with respect to how many outstanding NNTP requests will be allowed
at any one time. Stricly speaking, this is not mentioned in RFC-977, so
the default setting is to disable this feature. Enabling the window can
significantly improve the article transfer speed
The effect is particulary pronounced over
slow links and when many of the articles are already present in the
local spool, where an improvement in speed of over 10 times has been 
observed.
All this at the penalty of larger host newsserver load, obviously.
.TP
\fB-b\fP\fI minspool\fP, \fB--size\fP\fI minspool\fP
Specify the minimum incoming spool size. After every new group, if the
spool file has reached the byte size specified, a new spool batch will
be made. Setting this value to 1 will cause every newsgroup to be placed 
in a separate spool.
.TP
\fB-z\fP, \fB--sync\fP
Omit actual pulling of news articles. Instead, simply update
the host newsrc file (\fIin.hosts/spoolname\fP)
to synchronize with the currently highest available
article numbers from the server in question. This option can be useful when
a fresh local spool is initiated. No article posting will be attempted.
\fB-Z\fP, \fB--syncnew\fP
Omit actual pulling of news articles in previously unseen groups only.
The net effect is that newly added groups will start fetching from 
.BR "now on" ","
instead of from the first article available at the host server.
.TP
\fB--reset\fP
Ignore the latest article information in 
the host newsrc file (\fIin.hosts/spoolname\fP),
and attempt fetching 
.B all 
articles available from the server, subject to the normal history lookup
constraints.
This option is useful if the remote spool has been reconfigured.  
.TP
\fB-h\fP\fI historydb\fP, \fB--history\fP\fI historydb\fP
Specify the name of the history database file, used for checking
if news articles are already present in the spool.
Required only 
when using a name different from the default "\*h", or to prevent
history lookup - an empty argument "" preventing any referrence to
the news history database. 
.TP
\fB--active\fP\fI activefile\fP
Specify the name of the active newsgroup
file for incoming news.
Required only if different from the default value
.IR "\*a" "."
A leading '/' specifices a full path,	
a leading '.' is relative from the current directory, 
otherwise the name is relative to 
.IR "\*n" "."
.TP
\fB--newsfeeds\fP\fI newsfeedsfile\fP
Specify the name of the newsfeed specification file. This will override
the default both in C News (sys) and INN (newsfeeds) modes.
A leading '/' specifices a full path,	
a leading '.' is relative from the current directory, 
otherwise the name is relative to 
.IR "\*n" "."
.TP
\fB--incoming\fP\fI incomingdir\fP
Use 
.I incomingdir
as the incoming news article spool directory instead of the default
.BR "\*i" .
A leading '/' specifices a full path,	
a leading '.' is relative from the current directory, 
otherwise the name is relative to 
.IR "\*s" "."

.SH GENERAL OPTIONS
.TP
\fB-c\fP, \fB--cnews\fP
Set to C News mode as opposed to INN. Controls
details regarding handling of spool and lock files.
.TP
\fB-i\fP, \fB--inn\fP
Set to INN mode as opposed to C News. Controls
details regarding handling of spool and lock files.
.TP
\fB--home\fP\fI newshome\fP
Use 
.I newshome
as the news home directory instead of the default
.BR "\*n" .
A full path must be specified.
.TP
\fB-s\fP\fI spooldir\fP, \fB--spool\fP\fI spooldir\fP
Use 
.I spooldir
as the news article spool directory instead of the default
.BR "\*s" .
A full path must be specified.
.TP
\fB-t\fP\fI timeout\fP, \fB--timeout\fP\fI timeout\fP
Specify timeout for TCP/IP and lockfile operations, in seconds. The
default value is 600.
.TP
\fB--newline\fP
Uses single newline character as line terminator instead of the
carriage return, line feed sequence.
.TP
\fB-v\fP, \fB--version\fP
Display program version. Include this when reporting bugs.

.SH OPTIONS MOSTLY FOR TESTING
.TP
\fB-d\fP, \fB--debug\fP
Enable debugging. This diverts reporting to stderr instead of syslog
and turns on extra debugging output. 
Use twice to log NNTP commands,
use three times for additional debug output,
and four times to log all NNTP communications.
.TP
\fB-n\fP, \fB--noaction\fP
No-action flag, will "fake" an NNTP connection, and leave the outgoing
batch untouched.
Probably useful only with -d for debugging and dry-testing.
.TP
\fB-o\fP, \fB--keepold\fP
Keep the previous outgoing spool in an ".old" file. This might seem like
a useful option for ordinary use, but the problem is that a non-empty
file might cause a news watch program to believe there is a stale 
outgoing spool.
.TP
\fB-u\fP, \fB--noforce\fP
After the timeout of lockfile operations, just give up and
do not attempt to unlock the lockfiles and remove the stale process.

.SH OPERATION
.PP
The program should normally only be run by user
.IR \*u "."
.PP
When started,
.I NewsX
will go through the	      
.I spoolname
outgoing spool queue, and attempt to post all
articles therein to the NNTP server 
.IR hostname "."
.PP
If a username and password for use with the simple authorization protocol
have been supplied, they will be sent to the server first. If the
\fB-r\fP option is specified, a 'MODE READER' command will be sent.
.PP
When the outgoing transfer is finished, articles will be removed from the
outgoing spool queue if successful transfer has been acknowledged by 
the NNTP host, if the article was specified by the host as a duplicate
(already posted), or if a spooled article can no longer be found.
.PP
The fetch phase is then initiated. 
Articles available from the newsserver will be
fetched and placed in the incoming spool, ready to be injected into
the news system by     
.I newsrun
(C News) or
.I "rnews -U"  
(INN).
.PP
The groups are visited in the sequence that they appear in the
host newsrc file, \fIin.hosts/spoolname\fP. 
This may be used actively to prioritize between newsgroups.
A tag mechanism controlled by the
.B "-e"
option is available to limit the number of groups that will be fetched.
.PP
Group names not present in the
.I active
file will not be fetched. 
In addition, every group name is checked against the 
.B ME
and 
.I spoolname
entries in the
.I "sys"
(C News) or
.I "newsfeeds"
(INN) file, and only groups allowed there will actually be fetched.
.PP
In this way, the sys/newsfeed file is used to control which
newsgroups are actually received from the remote
site, in the same manner that the local server determines which outgoing
article will go where.
.PP
If an 
.B "-e"
option hasn't been specified, the local
.I "active"
file is then traversed to see if there are groups not mentioned in
the current host newsrc file.
Again, only groups allowed by 
.I "sys"
or
.I "newsfeeds"
is actually fetched. Since these groups don't have a starting point
specified, all available articles will be fetched.
.PP
To avoid transferring cross-posted articles more than once,
articles with messags IDs already fetched in the same session will
not be fetched again. 
.PP
To make multiple news sources to be used in an efficient manner, 
articles present in the
.I "history"
database will be skipped.
.PP
The pull phase can be omitted entirely by using the
.BR -g
option. 
.PP
Statistics on the connection will be logged to syslog (or stderr with
.BR -d ")."
The posted article count is the total number of
articles actually posted. 
The duplicate count is how many message IDs from posted messages
that were found to already exist on the remote system.
The missing count is those posted articles that could no longer be found
locally, usually because they were canceled locally, or perhaps since
they were expired already. 
.PP
The connection time and the total number of characters transferred via
the NNTP layer is logged, in addition to the
average speed of article transfer.
The speed given is the net rate, the calculation being
based on the actual number of characters belonging to news article head
and body parts.
.PP
A log file may be specified with the 
.B -l
option, and a folder of posted messages maintained with the
.B -f
option.

.SH SPECIAL CONNECT SEQUENCE
.PP
The 
.B -w
option specifies that a special connect sequence is required, and that
a script for this sequence can be found in the
.I "chatfile."
This file consists of lines that contains pattern receive and send pairs,
separated by blanks. The patterns may be enclosed in quotes.
The script is currently only available for the "telnet" protocol.
.PP
A typical invocation line would be:
.br
.na
.nf
	newsx -w chat.acme acme login.acme.net telnet
.PP
The file chat.acme could look like this:
.br
.na
.nf
	# login for acme.net NNTP
	login:		myusername
	Password:	mypassword
	$		"exec telnet news.acme.net nntp"
	ECHO
.PP
The script will have to be adapted for local conditions, of course. 
.PP
The special tag 
.B "ECHO"
specifies that line echo should be suppressed, required since the host 
telnet operates in line mode.
.PP
Since this file usually contains passwords and other sensitive information,
ensure that read access to it is limited.

.SH PROCESS STATUS 
.PP
The 
.B ps
process status will also show the current NewsX status. During the actual
news transfer phase, it will show which group and article number that is
being fetched. A continuous status can be obtained by the following shell
script:
.nf
.na
       while true; do
	   ps -ax | grep "newsx[(]"
	   sleep 5
       done

.SH LOG FILE FORMAT
.PP
The 
.I "-l"
log file of posted articles will contain one line for each article.
Each field is separated by a blank:
.IP "Month"
Standard 3 letter abbreviation. 
.IP "Date"
2 digits
.IP "HH:MM:SS"
Local time.			
.IP "Year"
4 digits.			
.IP "Spool"
Name of outgoing spool.        
.IP "<Msgid>"
Within angle brackets.	       
.IP "Filename"
As it appears in the spool file.
.IP "Sender"
The value of the Sender-field, or From-field if no Sender is available.
.IP "Status"
"OK" for successfully posted items, "Duplicate" for items already posted.
.IP "Lines"
Number of lines in the posting, separated from the status by a comma.

.SH HOST NEWSRC FILE FORMAT
.PP
For each incoming news source, there must be an 
.I "in.hosts/spoolname"
file that describes what the latest article is that has been fetched from
that particular host. 
.PP
As long as you want to get all news articles in the groups defined at your
local server, there is no need to do anything to make construct this file,
it will take care of itself.
.PP
The format of this file is simple:
.PP
Blank lines and lines starting with a '#' will be treated as comments.
.PP
Lines starting with a ':' indicates a tag for use with the 
.B "-e"
option.
.PP
Otherwise, each line consists of a newsgroup name and the first unread
article number, separated by whitespace. A missing article number 
corresponds to zero, meaning that all available articles on the
server will be read.
.PP
It is important to realize that each file belongs to one remote newsserver
alone, and should not be mixed.
.PP
If switching from reading news via an NNTP newsreader to fetching with
NewsX, it is possible to use the existing ".newsrc" file 
directly as basis for making an initial
.I "in.hosts/spoolname"
file. 

.SH INCOMING SPOOL FORMAT
.PP
The incoming spool consists of files with the file name ending by ".t".
Each file can contain many articles. Each article is prefixed by the following
header: 
.br
.nf
.na
	#! rnews \fBN\fP
.PP
The number \fBN\fP is the number of bytes of the article proper, not counting
the header line. The article follows after the header line. 
It appears exactly as received from the news server except that CR/LF 
sequences are replaced by proper newlines, and the terminating full stop is
not included.

.SH DIAGNOSTICS
.PP
NewsX returns error codes as follows:
.RS
0 - Successful completion
.br
1 - General system error
.br
2 - Incorrect arguments supplied.
.br
3 - Error connecting to remote host
.br
4 - NNTP Protocol error
.br
5 - Errors accessing outgoing spool file.
.br
6 - Errors accessing host newsrc file.
.br
7 - Errors accessing incoming spool file.
.br
8 - Errors accessing local 
.I "active"
and 
.I sys
files.
.br
9 - Socket access error (connection timeout, usually)
.br
10 - Errors accessing
.I authinfo
file.
.br
11 - Connect script failure.
.RE

.SH BUGS
.PP
There should have been a maximum retry count on article posting,
depending on the nature of the error.
.PP
Distribution fields are simply ignored. They are sort of getting 
out-of-fashion anyhow.
.PP
Beta test version, various bugs might occur. 

.SH FILES
.PP
For C News:
.IP "\*o/\fIspoolname\fP/togo"
Spool file 
.IP "\*o/\fIspoolname\fP/togo.old"
Previous spool file 
.IP "\*o/\fIspoolname\fP/LOCKb"
Lock file 
.IP "\*s/in.hosts/\fIspoolname\fP"
Incoming spool, host newsrc file. 
There should be one of these per external news server.
.IP "\*s/in.hosts/\fIspoolname\fP.tmp"
Incoming spool, temporary (while news are being pulled).
.IP "\*s/in.hosts/\fIspoolname\fP.old"
Previous generation of the external host 
.I newsrc
file.
.IP "\*i/.tmp.$$"
Incoming spool, temporary file. 
.I "$$"
is the process ID.
.IP "\*i/T.$$.S.t"
Incoming spool, when finished and ready for newsrun. 
.I "T"
is the current Unix time, 
.I $$
is the process ID, and, 
.I S
is a sequence number.
.IP "\*a"
Local active file, contains a list over all currently active
newsgroups in the local spool. This is used as a basis for
constructing a list over which newsgroups will actually be requested.
The basic format of each specification is:
.br
	site/exclusions:grouplist/distlist:flags:cmd
.IP
Only the site and the grouplist fields are used. The site is the name
of the spool, whereas the group list is a comma-separated list of group
pattern names. A !-prefix signifies exclusions, and the name "all" 
matches anything.
.IP "\*n/sys"
Newsserver configuration file. 
This is used as a filter against the local
.I active
list, deciding which newsgroups which will actually be pulled.
.IP "\*h"
.IP "\*h.pag"
.IP "\*h.dir"
Local news spool database.
.PP
For INN:
.IP "\*o/\fIspoolname\fP"
Spool file
.IP "\*o/\fIspoolname\fP.old"
Previous spool file
.IP "\*n/LOCK.\fIspoolname\fP"
Lock file
.IP "\*a"
Local active file, contains a list over all currently active
newsgroups in the local spool. This is used as a basis for
constructing a list over which newsgroups will actually be requested.
.IP "\*f"
Newsserver configuration file. 
This is used as a filter against the local
.I active
list, deciding which newsgroups which will actually be pulled.
The basic format of each specification is:
.br
	site/exclusions:grouplist/distlist:flags:param
.IP
Only the site and the grouplist fields are used. The site is the name
of the spool, whereas the group list is a comma-separated list of group
pattern names. A !-prefix signifies exclusions, and the name "*" matches
anything.
.IP "\*h"
.IP "\*h.pag"
.IP "\*h.dir"
Local news spool article database.

.SH AUTHOR
Egil Kvaleberg <egilk@sn.no>

.SH "SEE ALSO"
.br
C News:
.IR news (5),
.IR newsdb (5),
.IR newssys (5),
.IR rnews (8)
.br
INN:
.IR rnews (1),
.IR wildmat (3),
.IR active (5),
.IR history (5),
.IR newsfeeds (5),
.IR ctlinnd (8)
.br
RFC-977 \- Network News Transfer Protocol (NNTP)
.br
RFC-1036 \- Usenet Article Format
.br
http://home.sn.no/~egilk/ISP-Hookup-HOWTO.html
